#include <stdio.h>
#include <stdlib.h>

const int MAXFSIZE = 205;
const int MAXFACES = 256;
const int MAX = 1024;

struct Elem {
  int a,b;
  Elem *next;
  Elem() {}
  Elem(int aa,int bb,Elem *n) : a(aa),b(bb),next(n) {}
};

struct Point {
  int x,y,z;
  void Read() { scanf("%d%d%d",&x,&y,&z); }
};

struct Face {
  Point P[MAXFSIZE];
  int n;
  void Read();
  int Horizontal();
  void Add();
};

struct Line {
  int x1,x2,y;
  Line() {}
  Line(int xx1,int xx2,int yy):x1(xx1),x2(xx2),y(yy) {}
};

Elem *Tab[MAX];
int Volume;
int nFaces;
Face Faces[MAXFACES];

int min(int a,int b) { return a<b?a:b; }
int max(int a,int b) { return a>b?a:b; }

int cmp_Face(const void *v1,const void *v2) {
  return ((Face*)v1)->P[0].z - ((Face*)v2)->P[0].z;
}

int cmp_Line(const void *v1,const void *v2) {
  return ((Line*)v1)->y - ((Line*)v2)->y;
}

int NaLiscie(Elem *L,int x) {
  while(L!=NULL && L->b<=x) L=L->next;
  return (L!=NULL && L->a<=x);
}

Elem *Dodaj(Elem *L,int a,int b) {
  if(L==NULL) return new Elem(a,b,NULL);
  if(L->b<=a) { L->next = Dodaj(L->next,a,b); return L; }
  return new Elem(a,b,L);
}

Elem *Usun(Elem *L,int a,int b) {
  Elem *LL;
  
  if(L->b <=a) { L->next = Usun(L->next,a,b); return L; }
  
//  while(L->b <= a) L=L->next;
  LL=L; L=L->next;
  if(LL->b>b) L=new Elem(b,LL->b,L);
  if(LL->a<a) L=new Elem(LL->a,a,L);
  return L;
}

void Read() {
  int f;
  scanf("%d",&nFaces);
  for(f=0;f<nFaces;f++) Faces[f].Read();
}

void SortFaces() {
  int f;
  
  f=0;
  while(f<nFaces) {
    if(Faces[f].Horizontal()) f++;
    else Faces[f]=Faces[--nFaces];
  }
  qsort(Faces,nFaces,sizeof(Face),cmp_Face);
}

int Face::Horizontal() {
  int i;
  for(i=1;i<n;i++) if(P[i].z!=P[0].z) return 0;
  return 1;
}

void Face::Read() {
  int i;
  scanf("%d",&n);
  for(i=0;i<n;i++) P[i].Read();
  P[n]=P[0];
}

void Face::Add() {
  int z=P[0].z;
  int i,y,x,x1,x2,dy;
  static Line L[MAXFSIZE];
  static int XX[MAX];
  int nL;
  
  nL=0;
  for(i=0;i<n;i++) if(P[i].y==P[i+1].y) {
    L[nL++]=Line(P[i].x,P[i+1].x,P[i].y);
  }
  qsort(L,nL,sizeof(Line),cmp_Line);
  for(x=0;x<MAX;x++) XX[x]=0;
  for(i=0;i<nL-1;i++) {
    x1=min(L[i].x1,L[i].x2);
    x2=max(L[i].x1,L[i].x2);
    for(x=x1;x<x2;x++) XX[x]=!XX[x];
    
    y=L[i].y; dy=L[i+1].y-L[i].y;
    if(dy==0) continue;
    
    for(x=0;x<MAX;x++) if(XX[x]) {
      if(NaLiscie(Tab[x],y)) {
        Volume+=z*dy;
	Tab[x]=Usun(Tab[x],y,y+dy);
      }
      else {
        Volume-=z*dy;
	Tab[x]=Dodaj(Tab[x],y,y+dy);
      }
    }
  }
}

void ClearTab() {
  int x;
  for(x=0;x<MAX;x++)
    Tab[x]=NULL;
}

int main() {
  int T,i,f;
  scanf("%d",&T);
  for(i=0;i<T;i++) {
    Read();
    SortFaces();
    ClearTab();
    Volume=0;
    for(f=0;f<nFaces;f++) Faces[f].Add();
    printf("The bulk is composed of %d units.\n",Volume);
  }
  return 0;
}
